#ifndef printer_h
#define printer_h

#include "Arduino.h"

class Printer
{
	public:
		Printer();
		bool Open();
		bool Close();

		bool PrintLine(String line);
		bool PrintImage(byte* img);
			
		bool PrintDeviceInfos();
		bool PrintFullCharset();
		bool GetPaperStatus();
		bool GetSerialNumber(byte* img);
			
		void (*PaperRestored)(Printer *printer);
		void (*PaperBlocked)(Printer *printer);
    
	private:
		int _pin;
		bool _lastPaperStatus;
		byte WriteByte(byte data);
		void StartGraphicMode();
		bool ManagePaperStatus();
		bool PrintBuffer();
};

#endif
